﻿package  
{
	/*
  ————————————————————————————————————————————————————————————————————
  ————————————————————————————————————————————————————————————————————
	CURVE A TEXT 
			
// http://blog.shortfusion.com/index.cfm/2009/1/25/Circular-Text-In-Flex-Explained
  ————————————————————————————————————————————————————————————————————
  ————————————————————————————————————————————————————————————————————
*/
	
	import flash.text.TextFormat;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.geom.Point
	import flash.display.Sprite;
	
	public class CurveText  extends Sprite 
	{

		var TF:TextField
		var spacing:Number = 0;
		var radius:Number
		public var container:Sprite=new Sprite() // sprite qui contient TOUTES les lettres
		
		public function CurveText(texte:String, textFor:TextFormat, angle:int)
		
		{
/*————————————————————————————————————————————————————————————————————
  				       Début de package							
  ————————————————————————————————————————————————————————————————————*/
			
			TF = new TextField()
			TF.text = texte
			TF.setTextFormat(textFor)
			
/*————————————————————————————————————————————————————————————————————
  				      // longueur de l'arc de cercle 
  ————————————————————————————————————————————————————————————————————*/
			var longArcCercle:Number =  TF.textWidth

/*————————————————————————————————————————————————————————————————————
  				    // radius du cercle
  ————————————————————————————————————————————————————————————————————*/
			radius = longArcCercle*(360/angle)*1/(2*Math.PI)+50
			    var stepAngle:Number = degrees2radians(angle)/texte.length
/*————————————————————————————————————————————————————————————————————
  				   Iteration sur chaque lettre
  ————————————————————————————————————————————————————————————————————*/		 
		 for (var char:uint=0;char<texte.length;char++) 
		  	{
             // trace("angle rad", texte.charAt(char), radians2degrees(stepAngle)*char)
/*————————————————————————————————————————————————————————————————————
  				  TextField ds lequel glisser la lettre
  ————————————————————————————————————————————————————————————————————*/		
			  var tempText:TextField = new TextField();
			  		tempText.embedFonts = true
					tempText.autoSize = TextFieldAutoSize.CENTER;
					tempText.text = texte.charAt(char);
				 	tempText.setTextFormat(textFor)
					tempText.x=-tempText.textWidth/2 //on centre le TF à l'interieur du sprite
/*————————————————————————————————————————————————————————————————————
  				on glisse le TextFielsd precedent dans un Sprite
				on centre le TF à l'interieur du sprite
				la rotation s'effectue sur le sprite
  ————————————————————————————————————————————————————————————————————*/					  
			var clipText:Sprite = new Sprite()
			 		clipText.addChild(tempText)
               		clipText.x = radius * Math.cos(stepAngle*char) 
              		clipText.y = radius * Math.sin(stepAngle*char) 
					clipText.rotation = radians2degrees(stepAngle)*char +90
               
			   container.addChild(clipText);
          	}
			container.rotation = 180
			addChild(container)
			
		}
		
/*————————————————————————————————————————————————————————————————————
  				   fonctions de conversion
  ————————————————————————————————————————————————————————————————————*/		
		 private function degrees2radians(deg:Number):Number 
		 	{
     		return (2 * Math.PI * deg) / 360; 
			}
    	private function radians2degrees(rad:Number):Number 
			{            
          return rad * 180 / Math.PI; 
    	 	}

	}
	
}
